]> git.enpas.org Git - openwrt.git/blob - package/madwifi/files/lib/wifi/madwifi.sh
madwifi.sh channel fix
[openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5         local device="$1"
6         local wds
7         local adhoc ahdemo sta ap monitor
8         
9         config_get vifs "$device" vifs
10         for vif in $vifs; do
11         
12                 config_get ifname "$vif" ifname
13                 config_set "$vif" ifname "${ifname:-ath}"
14                 
15                 config_get mode "$vif" mode
16                 case "$mode" in
17                         adhoc|ahdemo|sta|ap|monitor)
18                                 append $mode "$vif"
19                         ;;
20                         wds)
21                                 config_get ssid "$vif" ssid
22                                 [ -z "$ssid" ] && continue
23
24                                 config_set "$vif" wds 1
25                                 config_set "$vif" mode sta
26                                 mode="sta"
27                                 addr="$ssid"
28                                 ${addr:+append $mode "$vif"}
29                         ;;
30                         *) echo "$device($vif): Invalid mode, ignored."; continue;;
31                 esac
32         done
33
34         case "${adhoc:+1}:${sta:+1}:${ap:+1}" in
35                 # valid mode combinations
36                 1::) wds="";;
37                 1::1);;
38                 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
39                 :1:);;
40                 ::1);;
41                 ::);;
42                 *) echo "$device: Invalid mode combination in config"; return 1;;
43         esac
44
45         config_set "$device" vifs "${sta:+$sta }${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${wds:+$wds }${monitor:+$monitor}"
46 }
47
48
49 disable_atheros() (
50         local device="$1"
51
52         set_wifi_down "$device"
53         
54         include /lib/network
55         cd /proc/sys/net
56         for dev in *; do
57                 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
58                         [ -f "/var/run/wifi-${dev}.pid" ] &&
59                                 kill "$(cat "/var/run/wifi-${dev}.pid")"
60                         ifconfig "$dev" down
61                         unbridge "$dev"
62                         wlanconfig "$dev" destroy
63                 }
64         done
65         return 0
66 )
67
68 enable_atheros() {
69         local device="$1"
70
71         config_get regdomain "$device" regdomain
72         [ -n "$regdomain" ] && echo "$regdomain" > /proc/sys/dev/$device/regdomain
73
74         config_get country "$device" country
75         [ -z "$country" ] && country="0"
76         echo "$country" > /proc/sys/dev/$device/countrycode
77
78         config_get_bool outdoor "$device" outdoor "0"
79         echo "$outdoor" > /proc/sys/dev/$device/outdoor
80
81         config_get channel "$device" channel
82         config_get vifs "$device" vifs
83         config_get txpower "$device" txpower
84
85         [ auto = "$channel" ] && channel=0
86
87         config_get_bool antdiv "$device" diversity
88         config_get antrx "$device" rxantenna
89         config_get anttx "$device" txantenna
90         config_get_bool softled "$device" softled 1
91
92         devname="$(cat /proc/sys/dev/$device/dev_name)"
93         antgpio=
94         case "$devname" in
95                 NanoStation2) antgpio=7;;
96                 NanoStation5) antgpio=1;;
97         esac
98         if [ -n "$antgpio" ]; then
99                 softled=0
100                 config_get antenna "$device" antenna
101                 case "$antenna" in
102                         external) antdiv=0; antrx=1; anttx=1 ;;
103                         horizontal) antdiv=0; antrx=1; anttx=1 ;;
104                         vertical) antdiv=0; antrx=2; anttx=2 ;;
105                         auto) antdiv=1; antrx=0; anttx=0 ;;
106                 esac
107                         
108                 [ -x "$(which gpioctl 2>/dev/null)" ] || antenna=
109                 case "$antenna" in
110                         horizontal|vertical|auto)
111                                 gpioctl "dirout" "$antgpio" >/dev/null 2>&1
112                                 gpioctl "set" "$antgpio" >/dev/null 2>&1
113                         ;;
114                         external)
115                                 gpioctl "dirout" "$antgpio" >/dev/null 2>&1
116                                 gpioctl "clear" "$antgpio" >/dev/null 2>&1
117                         ;;
118                 esac
119         fi
120
121         [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
122         [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
123         [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
124         [ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
125
126         config_get distance "$device" distance
127         [ -n "$distance" ] && sysctl -w dev."$device".distance="$distance" >&-
128
129         for vif in $vifs; do
130                 local start_hostapd= vif_txpower= nosbeacon=
131                 config_get ifname "$vif" ifname
132                 config_get enc "$vif" encryption
133                 config_get eap_type "$vif" eap_type
134                 config_get mode "$vif" mode
135                 
136                 case "$mode" in
137                         sta) config_get nosbeacon "$device" nosbeacon;;
138                         adhoc) config_get nosbeacon "$vif" sw_merge;;
139                 esac
140                 
141                 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
142                 [ $? -ne 0 ] && {
143                         echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
144                         continue
145                 }
146                 config_set "$vif" ifname "$ifname"
147
148                 config_get hwmode "$device" hwmode
149                 [ -z "$hwmode" ] && config_get hwmode "$device" mode
150
151                 pureg=0
152                 case "$hwmode" in
153                         *b) hwmode=11b;;
154                         *bg) hwmode=11g;;
155                         *g) hwmode=11g; pureg=1;;
156                         *gdt) hwmode=11gdt;;
157                         *a) hwmode=11a;;
158                         *adt) hwmode=11adt;;
159                         *ast) hwmode=11ast;;
160                         *fh) hwmode=fh;;
161                         *) hwmode=auto;;
162                 esac
163                 iwpriv "$ifname" mode "$hwmode"
164                 iwpriv "$ifname" pureg "$pureg"
165
166                 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
167
168                 config_get_bool hidden "$vif" hidden 0
169                 iwpriv "$ifname" hide_ssid "$hidden"
170
171                 config_get ff "$vif" ff
172                 if [ -n "$ff" ]; then
173                         iwpriv "$ifname" ff "$ff"
174                 fi
175
176                 config_get wds "$vif" wds
177                 case "$wds" in
178                         1|on|enabled) wds=1;;
179                         *) wds=0;;
180                 esac
181                 iwpriv "$ifname" wds "$wds"
182
183                 [ "$mode" = ap -a "$wds" = 1 ] && {
184                         config_get_bool wdssep "$vif" wdssep 1
185                         [ -n "$wdssep" ] && iwpriv "$ifname" wdssep "$wdssep"
186                 }
187
188                 case "$enc" in
189                         WEP|wep)
190                                 for idx in 1 2 3 4; do
191                                         config_get key "$vif" "key${idx}"
192                                         iwconfig "$ifname" enc "[$idx]" "${key:-off}"
193                                 done
194                                 config_get key "$vif" key
195                                 key="${key:-1}"
196                                 case "$key" in
197                                         [1234]) iwconfig "$ifname" enc "[$key]";;
198                                         *) iwconfig "$ifname" enc "$key";;
199                                 esac
200                         ;;
201                         psk*|wpa*)
202                                 start_hostapd=1
203                                 config_get key "$vif" key
204                         ;;
205                 esac
206
207                 case "$mode" in
208                         sta|adhoc|ahdemo)
209                                 config_get addr "$vif" bssid
210                                 [ -z "$addr" ] || { 
211                                         iwconfig "$ifname" ap "$addr"
212                                 }
213                         ;;
214                 esac
215
216                 config_get_bool bgscan "$vif" bgscan
217                 [ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
218
219                 config_get rate "$vif" rate
220                 [ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
221
222                 config_get mcast_rate "$vif" mcast_rate
223                 [ -n "$mcast_rate" ] && iwpriv "$ifname" mcast_rate "${mcast_rate%%.*}"
224
225                 config_get frag "$vif" frag
226                 [ -n "$frag" ] && iwconfig "$ifname" frag "${frag%%.*}"
227
228                 config_get rts "$vif" rts
229                 [ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
230
231                 config_get_bool comp "$vif" compression 0
232                 iwpriv "$ifname" compression "$comp"
233
234                 config_get_bool minrate "$vif" minrate
235                 [ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
236
237                 config_get_bool maxrate "$vif" maxrate
238                 [ -n "$maxrate" ] && iwpriv "$ifname" maxrate "$maxrate"
239
240                 config_get_bool burst "$vif" bursting
241                 [ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
242
243                 config_get_bool wmm "$vif" wmm
244                 [ -n "$wmm" ] && iwpriv "$ifname" wmm "$wmm"
245
246                 config_get_bool xr "$vif" xr
247                 [ -n "$xr" ] && iwpriv "$ifname" xr "$xr"
248
249                 config_get_bool ar "$vif" ar
250                 [ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
251
252                 config_get_bool beacon_power "$vif" beacon_power
253                 [ -n "$beacon_power" ] && iwpriv "$ifname" beacon_pwr "$beacon_power"
254
255                 config_get_bool doth "$vif" doth 0
256                 [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
257
258                 config_get_bool probereq "$vif" probereq
259                 [ -n "$probereq" ] && iwpriv "$ifname" probereq "$probereq"
260
261                 config_get maclist "$vif" maclist
262                 [ -n "$maclist" ] && {
263                         # flush MAC list
264                         iwpriv "$ifname" maccmd 3
265                         for mac in $maclist; do
266                                 iwpriv "$ifname" addmac "$mac"
267                         done
268                 }
269
270                 config_get macpolicy "$vif" macpolicy
271                 case "$macpolicy" in
272                         allow)
273                                 iwpriv "$ifname" maccmd 1
274                         ;;
275                         deny)
276                                 iwpriv "$ifname" maccmd 2
277                         ;;
278                         *)
279                                 # default deny policy if mac list exists
280                                 [ -n "$maclist" ] && iwpriv "$ifname" maccmd 2
281                         ;;
282                 esac
283
284                 ifconfig "$ifname" up
285
286                 local net_cfg bridge
287                 net_cfg="$(find_net_config "$vif")"
288                 [ -z "$net_cfg" ] || {
289                         bridge="$(bridge_interface "$net_cfg")"
290                         config_set "$vif" bridge "$bridge"
291                         start_net "$ifname" "$net_cfg"
292                 }
293
294                 config_get ssid "$vif" ssid
295                 [ -n "$ssid" ] && {
296                         iwconfig "$ifname" essid on
297                         iwconfig "$ifname" essid "$ssid"
298                 }
299
300                 set_wifi_up "$vif" "$ifname"
301
302                 # TXPower settings only work if device is up already
303                 # while atheros hardware theoretically is capable of per-vif (even per-packet) txpower
304                 # adjustment it does not work with the current atheros hal/madwifi driver
305
306                 config_get vif_txpower "$vif" txpower
307                 # use vif_txpower (from wifi-iface) instead of txpower (from wifi-device) if
308                 # the latter doesn't exist
309                 txpower="${txpower:-$vif_txpower}"
310                 [ -z "$txpower" ] || iwconfig "$ifname" txpower "${txpower%%.*}"
311
312                 case "$mode" in
313                         ap)
314                                 config_get_bool isolate "$vif" isolate 0
315                                 iwpriv "$ifname" ap_bridge "$((isolate^1))"
316
317                                 if [ -n "$start_hostapd" ] && eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
318                                         hostapd_setup_vif "$vif" madwifi || {
319                                                 echo "enable_atheros($device): Failed to set up hostapd for interface $ifname" >&2
320                                                 # make sure this wifi interface won't accidentally stay open without encryption
321                                                 ifconfig "$ifname" down
322                                                 wlanconfig "$ifname" destroy
323                                                 continue
324                                         }
325                                 fi
326                         ;;
327                         wds|sta)
328                                 if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
329                                         wpa_supplicant_setup_vif "$vif" madwifi || {
330                                                 echo "enable_atheros($device): Failed to set up wpa_supplicant for interface $ifname" >&2
331                                                 ifconfig "$ifname" down
332                                                 wlanconfig "$ifname" destroy
333                                                 continue
334                                         }
335                                 fi
336                         ;;
337                 esac
338         done
339 }
340
341
342 detect_atheros() {
343         cd /proc/sys/dev
344         [ -d ath ] || return
345         for dev in $(ls -d wifi* 2>&-); do
346                 config_get type "$dev" type
347                 devname="$(cat /proc/sys/dev/$dev/dev_name)"
348                 case "$devname" in
349                         NanoStation*)
350                                 EXTRA_DEV="
351 # Ubiquiti NanoStation features
352         option antenna  auto # (auto|horizontal|vertical|external)
353 "
354                         ;;
355                 esac
356                 [ "$type" = atheros ] && continue
357                 cat <<EOF
358 config wifi-device  $dev
359         option type     atheros
360         option channel  auto
361 $EXTRA_DEV
362         # REMOVE THIS LINE TO ENABLE WIFI:
363         option disabled 1
364
365 config wifi-iface
366         option device   $dev
367         option network  lan
368         option mode     ap
369         option ssid     OpenWrt
370         option encryption none
371 EOF
372         done
373 }